<?php
/*******************************************************************************
 * Holds any additional configuration for the first page of the pdf            *
 *                                                                             *
 * created on 2006-05-21                                                       *
 * created by M. Jansen <jansen@terrestris.de>                                 *
 * created for project 'regiochemie'                                           *
 *                                                                             *
 * (c) terrestris GbR, Bonn, Germany                                           *
 *                                                                             *
 *******************************************************************************/
// REQUIRE CENTRAL FUNCTIONS
require_once ('./additional_functions.inc.php');
/**
 * Pic on top of page
 */ 
$the_top_pic   = "./pics/top.png";
$pdf->addPngFromFile($the_top_pic, $mapOffset_left - $border - $border, $mapOffset_bottom + $map_height + $border + 1 , $map_width + $border + $border);


/** ****************************************************************************
 * SPECIAL COMMENT PLACE
 *******************************************************************************
 */
// this is the color of the lines:
$use_r = 180 / 255;
$use_g = 206 / 255;
$use_b = 140 / 255;

// width & height of Box:
$use_box_width  = 220;
$use_box_height = 130;

// Schreibe die Infos:
$additional_info_1_a = "<b>Bearbeitung:</b>";
$additional_info_1_b = $_REQUEST['bearbeitung'];
$additional_info_2_a = "<b>Ausdruck vom:</b>";
$additional_info_2_b = date("d.m.Y");
$additional_info_3_a = "<b>Mastab:</b>";
$additional_info_3_b = "1 : " . number_format($map_scale, 0, '', '.');
$additional_info_4_a = "<b>Anmerkung:</b>";
$arr_anmerkungen   = convert2lines($_REQUEST['anmerkung']);

// kiste unten rechts:
// Punkt unten links
$box_x1 = $mapOffset_left + $map_width + $linewidth_dashed - $use_box_width;
$box_y1 = $mapOffset_bottom -$linewidth_dashed;
// Punkt oben links
$box_x2 = $mapOffset_left + $map_width + $linewidth_dashed - $use_box_width;
$box_y2 = $mapOffset_bottom -$linewidth_dashed + $use_box_height; 
// punkt oben rechts
$box_x3 = $mapOffset_left + $map_width + $linewidth_dashed;
$box_y3 = $mapOffset_bottom -$linewidth_dashed + $use_box_height;
// punkt unten rechts
$box_x4 = $mapOffset_left + $map_width + $linewidth_dashed;
$box_y4 = $mapOffset_bottom -$linewidth_dashed;

// Zeichne
$pdf->saveState();
$pdf->setColor(1, 1, 1);
$pdf->setLineStyle(1);
$pdf->filledRectangle($box_x1, $box_y1, $use_box_width, $use_box_height);
$pdf->line($box_x1, $box_y1, $box_x2, $box_y2);
$pdf->line($box_x2, $box_y2, $box_x3, $box_y3);
$pdf->line($box_x3, $box_y3, $box_x4, $box_y4);
$pdf->line($box_x4, $box_y4, $box_x1, $box_y1);

$pdf->setColor(0, 0, 0);
$pdf->addText($box_x2 + 10, $box_y2 - 20, 8, $additional_info_1_a);
$pdf->addText($box_x2 + 90, $box_y2 - 20, 8, $additional_info_1_b);
$pdf->addText($box_x2 + 10, $box_y2 - 30, 8, $additional_info_2_a);
$pdf->addText($box_x2 + 90, $box_y2 - 30, 8, $additional_info_2_b);
$pdf->addText($box_x2 + 10, $box_y2 - 40, 8, $additional_info_3_a);
$pdf->addText($box_x2 + 90, $box_y2 - 40, 8, $additional_info_3_b);
$pdf->addText($box_x2 + 10, $box_y2 - 50, 8, $additional_info_4_a);

/**
 * ADDING 'Anmerkungskasten'
 */
$space_to_substract = 60;
$linecounter = 0;
foreach ($arr_anmerkungen as $single_line) {
  $use_space = $space_to_substract + $linecounter * 10;
  $pdf->addText($box_x2 + 15, $box_y2 - $use_space, 8, $single_line);
  $linecounter ++;
}
$pdf->restoreState();

/** ****************************************************************************
 * Copyright
 *******************************************************************************
 */
#(c)... on bottom of page
$copy_text_top = " Kreis Recklinghausen & WiN Emscherlippe GmbH";
$copy_text_bot = "<c:alink:http://www.chemieatlas.de/>"
				 . "www.chemieatlas.de"
				 . "</c:alink>";
$pdf->addText(593, 40, 8, $copy_text_top);
$next_x_pos = 593 + ($pdf->getTextWidth(8, $copy_text_top) / 2) - ($pdf->getTextWidth(8, $copy_text_bot) / 2);
$pdf->addText($next_x_pos, 31, 8, $copy_text_bot);

/** ****************************************************************************
 * Seitenummern
 *******************************************************************************

$pdf->ezStartPageNumbers($mapOffset_left + $map_width, mapOffset_bottom + $map_height + 95, 8, 'left', "Seite {PAGENUM} / {TOTALPAGENUM}");
 */

?>